Subject: [Roll] IANA registry for OFs

From: "Adrian Farrel" <[email-masked]>
Date: Mon, 11 Jun 2012 13:18:14 +0100

Hi,

If I understood this part of the thread correctly, you are suggesting revising
the current registry (http://www.iana.org/assignments/rpl/rpl.xml#ocp) that is
set up as a single range 0-65535 with "IETF review" allocation policy.

According to RFC 5226 that means "New values are assigned only through RFCs that
have been shepherded through the IESG as AD-Sponsored or IETF WG Documents"

It seems to me that this is adequate for immediate needs, but you might be
asking to relax this and partition the range for future use. You could consider
a range of first come first served code points, or a range (possibly just one).

Making any change to the registry would require a standards track RFC, and I
would suggest that, if this is what you want to achieve, you should start such a
document and equip it with some description of the reasoning/use-cases that
motivate you. It need not be a long document.

Cheers,
Adrian

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of Don
> Sturek
> Sent: 04 June 2012 14:21
> To: Pascal Thubert (pthubert); Ralph Droms; Michael Richardson
> Cc: [email-masked]
> Subject: Re: [Roll] knowing which multiple metrics matter: MRHOF related
> questions
> 
> Hi Pascal,
> 
> Having a range of reserved well known OF's from IANA makes sense.   This
> is the minimum requirement to make MrHOF work.
> 
> If we do intend to support flexibility in deployment (eg industry groups
> which may define their own OF's) then we would want a way to define on
> demand OF's.
> 
> Don
> 
> 
> 
> On 6/3/12 11:38 PM, "Pascal Thubert (pthubert)" <[email-masked]> wrote:
> 
> >Hi:
> >
> >I agree with Ralph that there is a choice to be made whether this OF is
> >one OF or a generic OF that is instantiated by metric (a toolbox).
> >
> >If it is a specific OF, it is fair to require from IANA a specific OF
> >number (1 in the IANA section) but then we can expect that all
> >implementations of this OF will behave the same.
> >
> >Here, the behavior will vary quite dramatically with some implementation
> >decisions (see the unresolved issue in the attached mail) and metric
> >choices (Ralph's point here).
> >
> >As it goes, we could figure that MrHof is not one but many OFs.  If
> >that's so then the OF number for the local variation should be assigned
> >consistently for a deployment as opposed to globally significant. There
> >could in fact be multiple MrHof in a same deployment.
> >
> >My point is somewhat analogous to the UDP ports. Should we have a range
> >for IANA reserved well known OFs, and then a range that would be assigned
> >on demand?
> >
> >Cheers,
> >
> >Pascal
> >
> >-----Original Message-----
> >From: Ralph Droms [mailto:[email-masked]]
> >Sent: vendredi 1 juin 2012 21:47
> >To: Michael Richardson
> >Cc: [email-masked]; Pascal Thubert (pthubert)
> >Subject: Re: [Roll] knowing which multiple metrics matter: MRHOF related
> >questions
> >
> >
> >On May 25, 2012, at 12:31 PM 5/25/12, Pascal Thubert (pthubert) wrote:
> >
> >> Hi Michael:
> >>
> >> I think RPL does not want to take party there. The OF is a piece of
> >>logic to tie metrics and policies together.
> >> As such, there could be multiple metrics as long as there is good logic
> >>to tie them in. for instance one would look at optimizing metric A
> >>within contraints as expressed by metric B and the OF model will allow
> >>that.
> >>
> >> OTOH, it a flows requires a certain optimization (say per one metric)
> >>and another requires something different, then certainly you want two
> >>instances.
> >>
> >> So ... it depends!
> >>
> >> Pascal
> >>
> >>
> >> -----Original Message-----
> >> From: [email-masked] [mailto:[email-masked]] On Behalf
> >> Of Michael Richardson
> >> Sent: vendredi 25 mai 2012 16:54
> >> To: [email-masked]
> >> Subject: [Roll] knowing which multiple metrics matter: MRHOF related
> >> questions
> >>
> >>
> >> Ralph asked some questions a few days ago.
> >> His originally DISCUSS is at:
> >>
> >> http://datatracker.ietf.org/doc/draft-ietf-roll-minrank-hysteresis-of/
> >> ballot/
> >>
> >> This was my reply.    I am particularly interested in replies from
> >> Pascal, Anders and Mukul about my assertion about how we would never
> >>pick RPL instances by metrics; that they would in fact be seperate RPL
> >>Instance numbers and DODAG values, and that these things would
> >>provisioned by the network installer.
> >>
> >> ====
> >>
> >> I'm going to reply to your comments in a different order than you asked
> >>them, because I think question #3 is most important, and the rest fall
> >>out of it.
> >>
> >>>>>>> "Ralph" == Ralph Droms <[email-masked]> writes:
> >>    Ralph> 3. Based on (1) and (2), would configuration and selection
> >>    Ralph> issues be ameliorated if the five candidate selected metrics
> >>    Ralph> were each asssigned a separate objective function?  Use of a
> >>    Ralph> separate OF code point for each of the five possible selected
> >>    Ralph> metrics would allow multiple RPL instances.
> >>
> >> I think that it's important to understand that ROLL has a whole palette
> >>of things that need to be provisioned by the "network operator".
> >>
> >> In contrast to the situation of ISPs and customers, where the ISP is
> >> the network operator, ROLL networks are more like highly orchestrated
> >> Enterprises: "all your host belong to us"
> >>
> >> so, when we write something like:
> >>    "The metric chosen by the network operator to use for path
> >>    selection."
> >> in section 2, we really mean:
> >>    "The metric chosen by the network operator and provisioned into
> >>    the node when the firmware was flashed to use for path selection."
> >
> >OK, so I get that the model is that MRHOF is a toolbox, where the
> >specific tools are chosen when the device is flashed.  In that case, I
> >think some additional review might be needed to ensure that the MRHOF
> >spec is internally consistent with that point of view.
> >
> >As one example, I think the "selected metric" should be called out
> >explicitly somewhere in section 5 and included in the list of configured
> >parameters in section 6.1.
> >
> >As another example, I read this text from section 3:
> >
> >   Rank is undefined for these node/link metrics: node state and
> >   attributes, throughput, and link color.  If the rank is undefined,
> >   the node must join one of the neighbors as a RPL Leaf node according
> >   to [RFC6550].
> >
> >to mean that if the selected metric is one of the metrics for which rank
> >is undefined, the node joins as a lead node.  But, how can that happen if
> >the selected metric is chosen by the network operator?
> >
> >> Ralph> 1.  Why is one objective function defined for several potential
> >> Ralph> metrics?  The details of MRHOF seem to preclude the
> >> Ralph> establishment of several RPL instances in an LLN, each of which
> >> Ralph> uses MRHOF with a different selected metric.
> >>
> >> If one had many different RPL Instances, then we would have different
> >> RPL Instance numbers in the RPL header.   There can be many different
> >> DODAG ("destinations") created within that instance.  The instances
> >>share a common set of (provisioned) parameters.
> >
> >How does a node know which RPL Instance number maps to which selected
> >metric?
> >
> >One way would be to specify that a node advertise ONLY the selected
> >metric for the RPL Instance in a DIO.
> >
> >> (To put it into DHCP terms: if we have multiple DHCP servers on a link,
> >> then one would expect them to all offer IP addresses in the same subnet.
> >> If one wanted to have addresses in different subnets, and let the host
> >> pick between them, then, one would need different layer-2s: different
> >> VLANs or ESSIDs, or... )
> >>
> >> If you feel that RPL is rather schizo about provisioning vs
> >>configuration, then I agree.  It's not always clear to me why some
> >>things are advertised while others are provisioned.
> >>
> >> In BGPv4, we calculate metrics by adding AS entries in the path.
> >> (It's always additive), and we add at least one AS entry to the path.
> >> One can AS-stuff and add more, but proper operation of BGP does not
> >>depend upon the exact algorithm used.
> >>
> >> Finally, my impression is that how the various metrics are used
> >>(singly, or in some combination) to calculate Rank Increase is a
> >>question of further research, experimentation, and trade secret.
> >
> >Well, OK, but for the purposes of the MRHOF spec, it seems pretty clear
> >to me there is one selected metric that is used across all nodes as a
> >strictly additive path cost computation.
> >
> >> So long as the Rank increases, and a node does not flap between
> >>parents, the exact details do not matter.  Each node can do it's parent
> >>selection based upon the available metrics on it's own.  It advertises
> >>the metrics it has.
> >>
> >> I hope the authors will correct me if I'm completely off here.
> >
> >I read the spec to require a single selected metric across the entire RPL
> >Instance.
> >
> >- Ralph
> >
> >>
> >>
> >>
> >>
> >>
> >> _______________________________________________
> >> Roll mailing list
> >> [email-masked]
> >> https://www.ietf.org/mailman/listinfo/roll
> >
> >_______________________________________________
> >Roll mailing list
> >[email-masked]
> >https://www.ietf.org/mailman/listinfo/roll
> 
> 
> _______________________________________________
> Roll mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/roll

---

From: Michael Richardson <[email-masked]>
Date: Mon, 11 Jun 2012 12:20:16 -0400

>>>>> "Adrian" == Adrian Farrel <[email-masked]> writes:
    Adrian> If I understood this part of the thread correctly, you are suggesting revising
    Adrian> the current registry (http://www.iana.org/assignments/rpl/rpl.xml#ocp) that is
    Adrian> set up as a single range 0-65535 with "IETF review" allocation policy.

    Adrian> According to RFC 5226 that means "New values are assigned only through RFCs that
    Adrian> have been shepherded through the IESG as AD-Sponsored or IETF WG Documents"

    Adrian> It seems to me that this is adequate for immediate needs, but you might be
    Adrian> asking to relax this and partition the range for future use. You could consider
    Adrian> a range of first come first served code points, or a range (possibly just one).

I think that it is fine to leave this as it is until we actually have an
industry association create a new OF.    
It is a shame that we didn't reserve some numbers for private use.

If you think we should reserve some for private use (1K is enough), and
set aside 8K or so for First Come First Served or Expert Review, I will
write that document.

-- 
Michael Richardson <[email-masked]>, Sandelman Software Works 
IETF ROLL WG co-chair.    http://datatracker.ietf.org/wg/roll/charter/